Index: lemon/time_measure.h
===================================================================
--- lemon/time_measure.h	(revision 318)
+++ lemon/time_measure.h	(revision 210)
@@ -293,4 +293,5 @@
   ///function, consider the usage of \ref TimeReport instead.
   ///
+  ///\todo This shouldn't be Unix (Linux) specific.
   ///\sa TimeReport
   class Timer
@@ -312,9 +313,10 @@
     ///Basically a Timer can be either running or stopped,
     ///but it provides a bit finer control on the execution.
-    ///The \ref lemon::Timer "Timer" also counts the number of
-    ///\ref lemon::Timer::start() "start()" executions, and it stops
-    ///only after the same amount (or more) \ref lemon::Timer::stop()
-    ///"stop()"s. This can be useful e.g. to compute the running time
+    ///The \ref Timer also counts the number of \ref start()
+    ///executions, and is stops only after the same amount (or more)
+    ///\ref stop() "stop()"s. This can be useful e.g. to compute
+    ///the running time
     ///of recursive functions.
+    ///
 
     ///@{
@@ -472,5 +474,5 @@
   };
 
-  ///Same as Timer but prints a report on destruction.
+  ///Same as \ref Timer but prints a report on destruction.
 
   ///Same as \ref Timer but prints a report on destruction.
@@ -486,4 +488,5 @@
   ///\sa Timer
   ///\sa NoTimeReport
+  ///\todo There is no test case for this
   class TimeReport : public Timer
   {
@@ -491,13 +494,13 @@
     std::ostream &_os;
   public:
-    ///Constructor
-
-    ///Constructor.
+    ///\e
+
     ///\param title This text will be printed before the ellapsed time.
     ///\param os The stream to print the report to.
     ///\param run Sets whether the timer should start immediately.
+
     TimeReport(std::string title,std::ostream &os=std::cerr,bool run=true)
       : Timer(run), _title(title), _os(os){}
-    ///Destructor that prints the ellapsed time
+    ///\e Prints the ellapsed time on destruction.
     ~TimeReport()
     {
@@ -506,5 +509,5 @@
   };
 
-  ///'Do nothing' version of TimeReport
+  ///'Do nothing' version of \ref TimeReport
 
   ///\sa TimeReport
Index: lemon/tolerance.h
===================================================================
--- lemon/tolerance.h	(revision 280)
+++ lemon/tolerance.h	(revision 209)
@@ -25,4 +25,6 @@
 ///floating point numbers.
 ///
+///\todo It should be in a module like "Basic tools"
+
 
 namespace lemon {
Index: lemon/unionfind.h
===================================================================
--- lemon/unionfind.h	(revision 236)
+++ lemon/unionfind.h	(revision 220)
@@ -498,5 +498,5 @@
     }
 
-    /// \brief LEMON style iterator for the representant items.
+    /// \brief Lemon style iterator for the representant items.
     ///
     /// ClassIt is a lemon style iterator for the components. It iterates
@@ -550,5 +550,5 @@
     };
 
-    /// \brief LEMON style iterator for the items of a component.
+    /// \brief Lemon style iterator for the items of a component.
     ///
     /// ClassIt is a lemon style iterator for the components. It iterates
@@ -808,5 +808,5 @@
     }
 
-    /// \brief LEMON style iterator for the classes.
+    /// \brief Lemon style iterator for the classes.
     ///
     /// ClassIt is a lemon style iterator for the components. It iterates
@@ -860,5 +860,5 @@
     };
 
-    /// \brief LEMON style iterator for the items of a component.
+    /// \brief Lemon style iterator for the items of a component.
     ///
     /// ClassIt is a lemon style iterator for the components. It iterates
@@ -1656,5 +1656,5 @@
     }
 
-    /// \brief LEMON style iterator for the items of a class.
+    /// \brief Lemon style iterator for the items of a class.
     ///
     /// ClassIt is a lemon style iterator for the components. It iterates
Index: test/CMakeLists.txt
===================================================================
--- test/CMakeLists.txt	(revision 225)
+++ test/CMakeLists.txt	(revision 203)
@@ -1,7 +1,7 @@
-INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
+include_directories (${LEMON_SOURCE_DIR})
 
-LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/lemon)
+link_directories (${LEMON_BINARY_DIR}/lemon)
 
-SET(TESTS
+set (TESTS
   bfs_test
   counter_test
@@ -17,12 +17,12 @@
   kruskal_test
   maps_test
+  path_test
   random_test
-  path_test
   time_measure_test
   unionfind_test)
 
-FOREACH(TEST_NAME ${TESTS})
-  ADD_EXECUTABLE(${TEST_NAME} ${TEST_NAME}.cc)
-  TARGET_LINK_LIBRARIES(${TEST_NAME} lemon)
-  ADD_TEST(${TEST_NAME} ${TEST_NAME})
-ENDFOREACH(TEST_NAME)
+foreach (TEST_NAME ${TESTS})
+  add_executable (${TEST_NAME} ${TEST_NAME}.cc)
+  target_link_libraries (${TEST_NAME} lemon)
+  add_test(${TEST_NAME} ${TEST_NAME})
+endforeach (TEST_NAME)
Index: test/Makefile.am
===================================================================
--- test/Makefile.am	(revision 228)
+++ test/Makefile.am	(revision 203)
@@ -4,4 +4,5 @@
 noinst_HEADERS += \
 	test/graph_test.h \
+	test/graph_maps_test.h \
         test/test_tools.h
 
Index: test/bfs_test.cc
===================================================================
--- test/bfs_test.cc	(revision 293)
+++ test/bfs_test.cc	(revision 222)
@@ -20,5 +20,4 @@
 #include <lemon/smart_graph.h>
 #include <lemon/list_graph.h>
-#include <lemon/lgf_reader.h>
 #include <lemon/bfs.h>
 #include <lemon/path.h>
@@ -29,76 +28,31 @@
 using namespace lemon;
 
-char test_lgf[] =
-  "@nodes\n"
-  "label\n"
-  "0\n"
-  "1\n"
-  "2\n"
-  "3\n"
-  "4\n"
-  "5\n"
-  "@arcs\n"
-  "     label\n"
-  "0 1  0\n"
-  "1 2  1\n"
-  "2 3  2\n"
-  "3 4  3\n"
-  "0 3  4\n"
-  "0 3  5\n"
-  "5 2  6\n"
-  "@attributes\n"
-  "source 0\n"
-  "target 4\n";
-
 void checkBfsCompile()
 {
   typedef concepts::Digraph Digraph;
   typedef Bfs<Digraph> BType;
-  typedef Digraph::Node Node;
-  typedef Digraph::Arc Arc;
 
   Digraph G;
-  Node s, t;
-  Arc e;
+  Digraph::Node n;
+  Digraph::Arc e;
   int l;
   bool b;
   BType::DistMap d(G);
   BType::PredMap p(G);
-  Path<Digraph> pp;
+  //  BType::PredNodeMap pn(G);
 
-  {
-    BType bfs_test(G);
+  BType bfs_test(G);
 
-    bfs_test.run(s);
-    bfs_test.run(s,t);
-    bfs_test.run();
+  bfs_test.run(n);
 
-    l  = bfs_test.dist(t);
-    e  = bfs_test.predArc(t);
-    s  = bfs_test.predNode(t);
-    b  = bfs_test.reached(t);
-    d  = bfs_test.distMap();
-    p  = bfs_test.predMap();
-    pp = bfs_test.path(t);
-  }
-  {
-    BType
-      ::SetPredMap<concepts::ReadWriteMap<Node,Arc> >
-      ::SetDistMap<concepts::ReadWriteMap<Node,int> >
-      ::SetReachedMap<concepts::ReadWriteMap<Node,bool> >
-      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
-      ::SetStandardProcessedMap
-      ::Create bfs_test(G);
+  l  = bfs_test.dist(n);
+  e  = bfs_test.predArc(n);
+  n  = bfs_test.predNode(n);
+  d  = bfs_test.distMap();
+  p  = bfs_test.predMap();
+  //  pn = bfs_test.predNodeMap();
+  b  = bfs_test.reached(n);
 
-    bfs_test.run(s);
-    bfs_test.run(s,t);
-    bfs_test.run();
-
-    l  = bfs_test.dist(t);
-    e  = bfs_test.predArc(t);
-    s  = bfs_test.predNode(t);
-    b  = bfs_test.reached(t);
-    pp = bfs_test.path(t);
-  }
+  Path<Digraph> pp = bfs_test.path(n);
 }
 
@@ -111,28 +65,12 @@
 
   Digraph g;
-  bool b;
-  bfs(g).run(Node());
-  b=bfs(g).run(Node(),Node());
-  bfs(g).run();
+  bfs(g,Node()).run();
+  bfs(g).source(Node()).run();
   bfs(g)
-    .predMap(concepts::ReadWriteMap<Node,Arc>())
-    .distMap(concepts::ReadWriteMap<Node,VType>())
+    .predMap(concepts::WriteMap<Node,Arc>())
+    .distMap(concepts::WriteMap<Node,VType>())
     .reachedMap(concepts::ReadWriteMap<Node,bool>())
     .processedMap(concepts::WriteMap<Node,bool>())
     .run(Node());
-  b=bfs(g)
-    .predMap(concepts::ReadWriteMap<Node,Arc>())
-    .distMap(concepts::ReadWriteMap<Node,VType>())
-    .reachedMap(concepts::ReadWriteMap<Node,bool>())
-    .processedMap(concepts::WriteMap<Node,bool>())
-    .path(concepts::Path<Digraph>())
-    .dist(VType())
-    .run(Node(),Node());
-  bfs(g)
-    .predMap(concepts::ReadWriteMap<Node,Arc>())
-    .distMap(concepts::ReadWriteMap<Node,VType>())
-    .reachedMap(concepts::ReadWriteMap<Node,bool>())
-    .processedMap(concepts::WriteMap<Node,bool>())
-    .run();
 }
 
@@ -143,18 +81,16 @@
   Digraph G;
   Node s, t;
+  PetStruct<Digraph> ps = addPetersen(G, 5);
 
-  std::istringstream input(test_lgf);
-  digraphReader(G, input).
-    node("source", s).
-    node("target", t).
-    run();
+  s=ps.outer[2];
+  t=ps.inner[0];
 
   Bfs<Digraph> bfs_test(G);
   bfs_test.run(s);
 
-  check(bfs_test.dist(t)==2,"Bfs found a wrong path.");
+  check(bfs_test.dist(t)==3,"Bfs found a wrong path." << bfs_test.dist(t));
 
   Path<Digraph> p = bfs_test.path(t);
-  check(p.length()==2,"path() found a wrong path.");
+  check(p.length()==3,"path() found a wrong path.");
   check(checkPath(G, p),"path() found a wrong path.");
   check(pathSource(G, p) == s,"path() found a wrong path.");
@@ -162,29 +98,23 @@
 
 
-  for(ArcIt a(G); a!=INVALID; ++a) {
-    Node u=G.source(a);
-    Node v=G.target(a);
+  for(ArcIt e(G); e!=INVALID; ++e) {
+    Node u=G.source(e);
+    Node v=G.target(e);
     check( !bfs_test.reached(u) ||
            (bfs_test.dist(v) <= bfs_test.dist(u)+1),
-           "Wrong output. " << G.id(u) << "->" << G.id(v));
+           "Wrong output.");
   }
 
   for(NodeIt v(G); v!=INVALID; ++v) {
-    if (bfs_test.reached(v)) {
-      check(v==s || bfs_test.predArc(v)!=INVALID, "Wrong tree.");
-      if (bfs_test.predArc(v)!=INVALID ) {
-        Arc a=bfs_test.predArc(v);
-        Node u=G.source(a);
-        check(u==bfs_test.predNode(v),"Wrong tree.");
-        check(bfs_test.dist(v) - bfs_test.dist(u) == 1,
-              "Wrong distance. Difference: "
-              << std::abs(bfs_test.dist(v) - bfs_test.dist(u) - 1));
-      }
+    check(bfs_test.reached(v),"Each node should be reached.");
+    if ( bfs_test.predArc(v)!=INVALID ) {
+      Arc e=bfs_test.predArc(v);
+      Node u=G.source(e);
+      check(u==bfs_test.predNode(v),"Wrong tree.");
+      check(bfs_test.dist(v) - bfs_test.dist(u) == 1,
+            "Wrong distance. Difference: "
+            << std::abs(bfs_test.dist(v) - bfs_test.dist(u)
+                        - 1));
     }
-  }
-
-  {
-    NullMap<Node,Arc> myPredMap;
-    bfs(G).predMap(myPredMap).run(s);
   }
 }
Index: test/dfs_test.cc
===================================================================
--- test/dfs_test.cc	(revision 293)
+++ test/dfs_test.cc	(revision 209)
@@ -20,5 +20,4 @@
 #include <lemon/smart_graph.h>
 #include <lemon/list_graph.h>
-#include <lemon/lgf_reader.h>
 #include <lemon/dfs.h>
 #include <lemon/path.h>
@@ -29,78 +28,31 @@
 using namespace lemon;
 
-char test_lgf[] =
-  "@nodes\n"
-  "label\n"
-  "0\n"
-  "1\n"
-  "2\n"
-  "3\n"
-  "4\n"
-  "5\n"
-  "6\n"
-  "@arcs\n"
-  "     label\n"
-  "0 1  0\n"
-  "1 2  1\n"
-  "2 3  2\n"
-  "1 4  3\n"
-  "4 2  4\n"
-  "4 5  5\n"
-  "5 0  6\n"
-  "6 3  7\n"
-  "@attributes\n"
-  "source 0\n"
-  "target 5\n";
-
 void checkDfsCompile()
 {
   typedef concepts::Digraph Digraph;
   typedef Dfs<Digraph> DType;
-  typedef Digraph::Node Node;
-  typedef Digraph::Arc Arc;
 
   Digraph G;
-  Node s, t;
-  Arc e;
+  Digraph::Node n;
+  Digraph::Arc e;
   int l;
   bool b;
   DType::DistMap d(G);
   DType::PredMap p(G);
-  Path<Digraph> pp;
+  //  DType::PredNodeMap pn(G);
 
-  {
-    DType dfs_test(G);
+  DType dfs_test(G);
 
-    dfs_test.run(s);
-    dfs_test.run(s,t);
-    dfs_test.run();
+  dfs_test.run(n);
 
-    l  = dfs_test.dist(t);
-    e  = dfs_test.predArc(t);
-    s  = dfs_test.predNode(t);
-    b  = dfs_test.reached(t);
-    d  = dfs_test.distMap();
-    p  = dfs_test.predMap();
-    pp = dfs_test.path(t);
-  }
-  {
-    DType
-      ::SetPredMap<concepts::ReadWriteMap<Node,Arc> >
-      ::SetDistMap<concepts::ReadWriteMap<Node,int> >
-      ::SetReachedMap<concepts::ReadWriteMap<Node,bool> >
-      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
-      ::SetStandardProcessedMap
-      ::Create dfs_test(G);
+  l  = dfs_test.dist(n);
+  e  = dfs_test.predArc(n);
+  n  = dfs_test.predNode(n);
+  d  = dfs_test.distMap();
+  p  = dfs_test.predMap();
+  //  pn = dfs_test.predNodeMap();
+  b  = dfs_test.reached(n);
 
-    dfs_test.run(s);
-    dfs_test.run(s,t);
-    dfs_test.run();
-
-    l  = dfs_test.dist(t);
-    e  = dfs_test.predArc(t);
-    s  = dfs_test.predNode(t);
-    b  = dfs_test.reached(t);
-    pp = dfs_test.path(t);
-  }
+  Path<Digraph> pp = dfs_test.path(n);
 }
 
@@ -113,28 +65,12 @@
 
   Digraph g;
-  bool b;
-  dfs(g).run(Node());
-  b=dfs(g).run(Node(),Node());
-  dfs(g).run();
+  dfs(g,Node()).run();
+  dfs(g).source(Node()).run();
   dfs(g)
-    .predMap(concepts::ReadWriteMap<Node,Arc>())
-    .distMap(concepts::ReadWriteMap<Node,VType>())
+    .predMap(concepts::WriteMap<Node,Arc>())
+    .distMap(concepts::WriteMap<Node,VType>())
     .reachedMap(concepts::ReadWriteMap<Node,bool>())
     .processedMap(concepts::WriteMap<Node,bool>())
     .run(Node());
-  b=dfs(g)
-    .predMap(concepts::ReadWriteMap<Node,Arc>())
-    .distMap(concepts::ReadWriteMap<Node,VType>())
-    .reachedMap(concepts::ReadWriteMap<Node,bool>())
-    .processedMap(concepts::WriteMap<Node,bool>())
-    .path(concepts::Path<Digraph>())
-    .dist(VType())
-    .run(Node(),Node());
-  dfs(g)
-    .predMap(concepts::ReadWriteMap<Node,Arc>())
-    .distMap(concepts::ReadWriteMap<Node,VType>())
-    .reachedMap(concepts::ReadWriteMap<Node,bool>())
-    .processedMap(concepts::WriteMap<Node,bool>())
-    .run();
 }
 
@@ -145,10 +81,8 @@
   Digraph G;
   Node s, t;
+  PetStruct<Digraph> ps = addPetersen(G, 5);
 
-  std::istringstream input(test_lgf);
-  digraphReader(G, input).
-    node("source", s).
-    node("target", t).
-    run();
+  s=ps.outer[2];
+  t=ps.inner[0];
 
   Dfs<Digraph> dfs_test(G);
@@ -162,20 +96,13 @@
 
   for(NodeIt v(G); v!=INVALID; ++v) {
-    if (dfs_test.reached(v)) {
-      check(v==s || dfs_test.predArc(v)!=INVALID, "Wrong tree.");
-      if (dfs_test.predArc(v)!=INVALID ) {
-        Arc e=dfs_test.predArc(v);
-        Node u=G.source(e);
-        check(u==dfs_test.predNode(v),"Wrong tree.");
-        check(dfs_test.dist(v) - dfs_test.dist(u) == 1,
-              "Wrong distance. (" << dfs_test.dist(u) << "->"
-              << dfs_test.dist(v) << ")");
-      }
+    check(dfs_test.reached(v),"Each node should be reached.");
+    if ( dfs_test.predArc(v)!=INVALID ) {
+      Arc e=dfs_test.predArc(v);
+      Node u=G.source(e);
+      check(u==dfs_test.predNode(v),"Wrong tree.");
+      check(dfs_test.dist(v) - dfs_test.dist(u) == 1,
+            "Wrong distance. (" << dfs_test.dist(u) << "->"
+            <<dfs_test.dist(v) << ')');
     }
-  }
-
-  {
-    NullMap<Node,Arc> myPredMap;
-    dfs(G).predMap(myPredMap).run(s);
   }
 }
Index: test/digraph_test.cc
===================================================================
--- test/digraph_test.cc	(revision 228)
+++ test/digraph_test.cc	(revision 209)
@@ -25,61 +25,10 @@
 #include "test_tools.h"
 #include "graph_test.h"
+#include "graph_maps_test.h"
 
 using namespace lemon;
 using namespace lemon::concepts;
 
-template <class Digraph>
-void checkDigraph() {
-  TEMPLATE_DIGRAPH_TYPEDEFS(Digraph);
-  Digraph G;
-
-  checkGraphNodeList(G, 0);
-  checkGraphArcList(G, 0);
-
-  Node
-    n1 = G.addNode(),
-    n2 = G.addNode(),
-    n3 = G.addNode();
-  checkGraphNodeList(G, 3);
-  checkGraphArcList(G, 0);
-
-  Arc a1 = G.addArc(n1, n2);
-  check(G.source(a1) == n1 && G.target(a1) == n2, "Wrong arc");
-  checkGraphNodeList(G, 3);
-  checkGraphArcList(G, 1);
-
-  checkGraphOutArcList(G, n1, 1);
-  checkGraphOutArcList(G, n2, 0);
-  checkGraphOutArcList(G, n3, 0);
-
-  checkGraphInArcList(G, n1, 0);
-  checkGraphInArcList(G, n2, 1);
-  checkGraphInArcList(G, n3, 0);
-
-  checkGraphConArcList(G, 1);
-
-  Arc a2 = G.addArc(n2, n1), a3 = G.addArc(n2, n3), a4 = G.addArc(n2, n3);
-  checkGraphNodeList(G, 3);
-  checkGraphArcList(G, 4);
-
-  checkGraphOutArcList(G, n1, 1);
-  checkGraphOutArcList(G, n2, 3);
-  checkGraphOutArcList(G, n3, 0);
-
-  checkGraphInArcList(G, n1, 1);
-  checkGraphInArcList(G, n2, 1);
-  checkGraphInArcList(G, n3, 2);
-
-  checkGraphConArcList(G, 4);
-
-  checkNodeIds(G);
-  checkArcIds(G);
-  checkGraphNodeMap(G);
-  checkGraphArcMap(G);
-
-}
-
-
-void checkConcepts() {
+void check_concepts() {
   { // Checking digraph components
     checkConcept<BaseDigraphComponent, BaseDigraphComponent >();
@@ -103,4 +52,5 @@
     checkConcept<ClearableDigraphComponent<>, ListDigraph>();
     checkConcept<ErasableDigraphComponent<>, ListDigraph>();
+    checkDigraphIterators<ListDigraph>();
   }
   { // Checking SmartDigraph
@@ -109,15 +59,18 @@
     checkConcept<ExtendableDigraphComponent<>, SmartDigraph>();
     checkConcept<ClearableDigraphComponent<>, SmartDigraph>();
+    checkDigraphIterators<SmartDigraph>();
   }
 //  { // Checking FullDigraph
 //    checkConcept<Digraph, FullDigraph>();
+//    checkDigraphIterators<FullDigraph>();
 //  }
 //  { // Checking HyperCubeDigraph
 //    checkConcept<Digraph, HyperCubeDigraph>();
+//    checkDigraphIterators<HyperCubeDigraph>();
 //  }
 }
 
 template <typename Digraph>
-void checkDigraphValidity() {
+void check_graph_validity() {
   TEMPLATE_DIGRAPH_TYPEDEFS(Digraph);
   Digraph g;
@@ -140,5 +93,5 @@
 
 template <typename Digraph>
-void checkDigraphValidityErase() {
+void check_graph_validity_erase() {
   TEMPLATE_DIGRAPH_TYPEDEFS(Digraph);
   Digraph g;
@@ -168,18 +121,24 @@
 }
 
-void checkDigraphs() {
+void check_digraphs() {
   { // Checking ListDigraph
     checkDigraph<ListDigraph>();
-    checkDigraphValidityErase<ListDigraph>();
+    checkGraphNodeMap<ListDigraph>();
+    checkGraphArcMap<ListDigraph>();
+
+    check_graph_validity_erase<ListDigraph>();
   }
   { // Checking SmartDigraph
     checkDigraph<SmartDigraph>();
-    checkDigraphValidity<SmartDigraph>();
+    checkGraphNodeMap<SmartDigraph>();
+    checkGraphArcMap<SmartDigraph>();
+
+    check_graph_validity<SmartDigraph>();
   }
 }
 
 int main() {
-  checkDigraphs();
-  checkConcepts();
+  check_concepts();
+  check_digraphs();
   return 0;
 }
Index: test/dijkstra_test.cc
===================================================================
--- test/dijkstra_test.cc	(revision 293)
+++ test/dijkstra_test.cc	(revision 220)
@@ -20,8 +20,6 @@
 #include <lemon/smart_graph.h>
 #include <lemon/list_graph.h>
-#include <lemon/lgf_reader.h>
 #include <lemon/dijkstra.h>
 #include <lemon/path.h>
-#include <lemon/bin_heap.h>
 
 #include "graph_test.h"
@@ -29,25 +27,4 @@
 
 using namespace lemon;
-
-char test_lgf[] =
-  "@nodes\n"
-  "label\n"
-  "0\n"
-  "1\n"
-  "2\n"
-  "3\n"
-  "4\n"
-  "@arcs\n"
-  "     label length\n"
-  "0 1  0     1\n"
-  "1 2  1     1\n"
-  "2 3  2     1\n"
-  "0 3  4     5\n"
-  "0 3  5     10\n"
-  "0 3  6     7\n"
-  "4 2  7     1\n"
-  "@attributes\n"
-  "source 0\n"
-  "target 3\n";
 
 void checkDijkstraCompile()
@@ -57,52 +34,28 @@
   typedef concepts::ReadMap<Digraph::Arc,VType> LengthMap;
   typedef Dijkstra<Digraph, LengthMap> DType;
-  typedef Digraph::Node Node;
-  typedef Digraph::Arc Arc;
 
   Digraph G;
-  Node s, t;
-  Arc e;
+  Digraph::Node n;
+  Digraph::Arc e;
   VType l;
   bool b;
   DType::DistMap d(G);
   DType::PredMap p(G);
+  //  DType::PredNodeMap pn(G);
   LengthMap length;
-  Path<Digraph> pp;
 
-  {
-    DType dijkstra_test(G,length);
+  DType dijkstra_test(G,length);
 
-    dijkstra_test.run(s);
-    dijkstra_test.run(s,t);
+  dijkstra_test.run(n);
 
-    l  = dijkstra_test.dist(t);
-    e  = dijkstra_test.predArc(t);
-    s  = dijkstra_test.predNode(t);
-    b  = dijkstra_test.reached(t);
-    d  = dijkstra_test.distMap();
-    p  = dijkstra_test.predMap();
-    pp = dijkstra_test.path(t);
-  }
-  {
-    DType
-      ::SetPredMap<concepts::ReadWriteMap<Node,Arc> >
-      ::SetDistMap<concepts::ReadWriteMap<Node,VType> >
-      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
-      ::SetStandardProcessedMap
-      ::SetOperationTraits<DijkstraWidestPathOperationTraits<VType> >
-      ::SetHeap<BinHeap<VType, concepts::ReadWriteMap<Node,int> > >
-      ::SetStandardHeap<BinHeap<VType, concepts::ReadWriteMap<Node,int> > >
-      ::Create dijkstra_test(G,length);
+  l  = dijkstra_test.dist(n);
+  e  = dijkstra_test.predArc(n);
+  n  = dijkstra_test.predNode(n);
+  d  = dijkstra_test.distMap();
+  p  = dijkstra_test.predMap();
+  //  pn = dijkstra_test.predNodeMap();
+  b  = dijkstra_test.reached(n);
 
-    dijkstra_test.run(s);
-    dijkstra_test.run(s,t);
-
-    l  = dijkstra_test.dist(t);
-    e  = dijkstra_test.predArc(t);
-    s  = dijkstra_test.predNode(t);
-    b  = dijkstra_test.reached(t);
-    pp = dijkstra_test.path(t);
-  }
-
+  Path<Digraph> pp = dijkstra_test.path(n);
 }
 
@@ -116,19 +69,10 @@
 
   Digraph g;
-  bool b;
-  dijkstra(g,LengthMap()).run(Node());
-  b=dijkstra(g,LengthMap()).run(Node(),Node());
+  dijkstra(g,LengthMap(),Node()).run();
+  dijkstra(g,LengthMap()).source(Node()).run();
   dijkstra(g,LengthMap())
-    .predMap(concepts::ReadWriteMap<Node,Arc>())
-    .distMap(concepts::ReadWriteMap<Node,VType>())
-    .processedMap(concepts::WriteMap<Node,bool>())
+    .predMap(concepts::WriteMap<Node,Arc>())
+    .distMap(concepts::WriteMap<Node,VType>())
     .run(Node());
-  b=dijkstra(g,LengthMap())
-    .predMap(concepts::ReadWriteMap<Node,Arc>())
-    .distMap(concepts::ReadWriteMap<Node,VType>())
-    .processedMap(concepts::WriteMap<Node,bool>())
-    .path(concepts::Path<Digraph>())
-    .dist(VType())
-    .run(Node(),Node());
 }
 
@@ -141,11 +85,13 @@
   Node s, t;
   LengthMap length(G);
+  PetStruct<Digraph> ps = addPetersen(G, 5);
 
-  std::istringstream input(test_lgf);
-  digraphReader(G, input).
-    arcMap("length", length).
-    node("source", s).
-    node("target", t).
-    run();
+  for(int i=0;i<5;i++) {
+    length[ps.outcir[i]]=4;
+    length[ps.incir[i]]=1;
+    length[ps.chords[i]]=10;
+  }
+  s=ps.outer[0];
+  t=ps.inner[1];
 
   Dijkstra<Digraph, LengthMap>
@@ -153,8 +99,8 @@
   dijkstra_test.run(s);
 
-  check(dijkstra_test.dist(t)==3,"Dijkstra found a wrong path.");
+  check(dijkstra_test.dist(t)==13,"Dijkstra found a wrong path.");
 
   Path<Digraph> p = dijkstra_test.path(t);
-  check(p.length()==3,"path() found a wrong path.");
+  check(p.length()==4,"getPath() found a wrong path.");
   check(checkPath(G, p),"path() found a wrong path.");
   check(pathSource(G, p) == s,"path() found a wrong path.");
@@ -166,19 +112,17 @@
     check( !dijkstra_test.reached(u) ||
            (dijkstra_test.dist(v) - dijkstra_test.dist(u) <= length[e]),
-           "Wrong output. dist(target)-dist(source)-arc_length=" <<
+           "dist(target)-dist(source)-arc_length= " <<
            dijkstra_test.dist(v) - dijkstra_test.dist(u) - length[e]);
   }
 
-  for(NodeIt v(G); v!=INVALID; ++v) {
-    if (dijkstra_test.reached(v)) {
-      check(v==s || dijkstra_test.predArc(v)!=INVALID, "Wrong tree.");
-      if (dijkstra_test.predArc(v)!=INVALID ) {
-        Arc e=dijkstra_test.predArc(v);
-        Node u=G.source(e);
-        check(u==dijkstra_test.predNode(v),"Wrong tree.");
-        check(dijkstra_test.dist(v) - dijkstra_test.dist(u) == length[e],
-              "Wrong distance! Difference: " <<
-              std::abs(dijkstra_test.dist(v)-dijkstra_test.dist(u)-length[e]));
-      }
+  for(NodeIt v(G); v!=INVALID; ++v){
+    check(dijkstra_test.reached(v),"Each node should be reached.");
+    if ( dijkstra_test.predArc(v)!=INVALID ) {
+      Arc e=dijkstra_test.predArc(v);
+      Node u=G.source(e);
+      check(u==dijkstra_test.predNode(v),"Wrong tree.");
+      check(dijkstra_test.dist(v) - dijkstra_test.dist(u) == length[e],
+            "Wrong distance! Difference: " <<
+            std::abs(dijkstra_test.dist(v)-dijkstra_test.dist(u)-length[e]));
     }
   }
Index: test/dim_test.cc
===================================================================
--- test/dim_test.cc	(revision 253)
+++ test/dim_test.cc	(revision 209)
@@ -51,36 +51,32 @@
   check(p.x==1 && p.y==2, "Wrong dim2::Point division by a scalar.");
 
-  typedef dim2::Box<int> Box;
-  Box box1;
-  check(box1.empty(), "Wrong empty() in dim2::Box.");
+  typedef dim2::BoundingBox<int> BB;
+  BB box1;
+  check(box1.empty(), "Wrong empty() in dim2::BoundingBox.");
 
   box1.add(a);
-  check(!box1.empty(), "Wrong empty() in dim2::Box.");
+  check(!box1.empty(), "Wrong empty() in dim2::BoundingBox.");
   box1.add(b);
 
-  check(box1.left()==1 && box1.bottom()==2 &&
-        box1.right()==3 && box1.top()==4,
-        "Wrong addition of points to dim2::Box.");
+  check(box1.bottomLeft().x==1 &&
+        box1.bottomLeft().y==2 &&
+        box1.topRight().x==3 &&
+        box1.topRight().y==4,
+        "Wrong addition of points to dim2::BoundingBox.");
 
-  check(box1.inside(Point(2,3)), "Wrong inside() in dim2::Box.");
-  check(box1.inside(Point(1,3)), "Wrong inside() in dim2::Box.");
-  check(!box1.inside(Point(0,3)), "Wrong inside() in dim2::Box.");
+  p.x=2; p.y=3;
+  check(box1.inside(p), "Wrong inside() in dim2::BoundingBox.");
 
-  Box box2(Point(2,2));
-  check(!box2.empty(), "Wrong empty() in dim2::Box.");
+  p.x=1; p.y=3;
+  check(box1.inside(p), "Wrong inside() in dim2::BoundingBox.");
 
-  box2.bottomLeft(Point(2,0));
-  box2.topRight(Point(5,3));
-  Box box3 = box1 & box2;
-  check(!box3.empty() &&
-        box3.left()==2 && box3.bottom()==2 &&
-        box3.right()==3 && box3.top()==3,
-        "Wrong intersection of two dim2::Box objects.");
+  p.x=0; p.y=3;
+  check(!box1.inside(p), "Wrong inside() in dim2::BoundingBox.");
 
-  box1.add(box2);
-  check(!box1.empty() &&
-        box1.left()==1 && box1.bottom()==0 &&
-        box1.right()==5 && box1.top()==4,
-        "Wrong addition of two dim2::Box objects.");
+  BB box2(p);
+  check(!box2.empty(), "Wrong empty() in dim2::BoundingBox.");
+
+  box2.add(box1);
+  check(box2.inside(p), "Wrong inside() in dim2::BoundingBox.");
 
   return 0;
Index: test/error_test.cc
===================================================================
--- test/error_test.cc	(revision 277)
+++ test/error_test.cc	(revision 209)
@@ -32,8 +32,4 @@
 #endif
 
-#ifdef NDEBUG
-#undef NDEBUG
-#endif
-
 //checking disabled asserts
 #define LEMON_DISABLE_ASSERTS
@@ -48,7 +44,12 @@
 }
 
+void fixme_disable() {
+  LEMON_FIXME("fixme_disable() is fixme!");
+}
+
 void check_assertion_disable() {
   no_assertion_text_disable();
   assertion_text_disable();
+  fixme_disable();
 }
 #undef LEMON_DISABLE_ASSERTS
@@ -74,8 +75,13 @@
 }
 
+void fixme_custom() {
+  LEMON_FIXME("fixme_custom() is fixme!");
+}
+
 void check_assertion_custom() {
   no_assertion_text_custom();
   assertion_text_custom();
-  check(cnt == 1, "The custom assert handler does not work");
+  fixme_custom();
+  check(cnt == 2, "The custom assert handler does not work");
 }
 
Index: test/graph_copy_test.cc
===================================================================
--- test/graph_copy_test.cc	(revision 282)
+++ test/graph_copy_test.cc	(revision 220)
@@ -64,9 +64,9 @@
   ListDigraph::ArcMap<SmartDigraph::Arc> ecr(to);
 
-  digraphCopy(from, to).
-    nodeMap(fnm, tnm).arcMap(fam, tam).
+  DigraphCopy<ListDigraph, SmartDigraph>(to, from).
+    nodeMap(tnm, fnm).arcMap(tam, fam).
     nodeRef(nr).arcRef(er).
     nodeCrossRef(ncr).arcCrossRef(ecr).
-    node(fn, tn).arc(fa, ta).run();
+    node(tn, fn).arc(ta, fa).run();
 
   for (SmartDigraph::NodeIt it(from); it != INVALID; ++it) {
@@ -139,9 +139,9 @@
   ListGraph::EdgeMap<SmartGraph::Edge> ecr(to);
 
-  graphCopy(from, to).
-    nodeMap(fnm, tnm).arcMap(fam, tam).edgeMap(fem, tem).
+  GraphCopy<ListGraph, SmartGraph>(to, from).
+    nodeMap(tnm, fnm).arcMap(tam, fam).edgeMap(tem, fem).
     nodeRef(nr).arcRef(ar).edgeRef(er).
     nodeCrossRef(ncr).arcCrossRef(acr).edgeCrossRef(ecr).
-    node(fn, tn).arc(fa, ta).edge(fe, te).run();
+    node(tn, fn).arc(ta, fa).edge(te, fe).run();
 
   for (SmartGraph::NodeIt it(from); it != INVALID; ++it) {
